Bug 87813 - SIDEBAR: Incorporating the effects list into the animation tab
Summary: SIDEBAR: Incorporating the effects list into the animation tab
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Impress (show other bugs)
Version:
(earliest affected)
4.5.0.0.alpha0+ Master
Hardware: Other All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard: target:5.2.0
Keywords: difficultyInteresting, easyHack, skillCpp, topicUI
Depends on:
Blocks: Sidebar-Custom-Animation
  Show dependency treegraph
 
Reported: 2014-12-29 01:32 UTC by Yousuf Philips (jay)
Modified: 2017-10-31 21:56 UTC (History)
9 users (show)

See Also:
Crash report or crash signature:


Attachments
mockup of idea 1 (33.71 KB, image/png)
2014-12-31 23:58 UTC, Yousuf Philips (jay)
Details
Old Custom Animation Pane (45.52 KB, image/png)
2016-10-22 19:11 UTC, Gizze
Details
New Custom Animation Pane (61.03 KB, image/png)
2016-10-22 19:15 UTC, Gizze
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Yousuf Philips (jay) 2014-12-29 01:32:45 UTC
In impress, in order to add an effect, you click on a add effect button which opens up a dialog where you select the effect you want to add. This seems to be a very clumsy way of going about this when the contents of this dialog could easily be integrated into the sidebar with a drop down list for effect category and (ideally) a listbox for the effects list.

Another alternative is to have a single drop down list or listbox listing the most important entries from each category that a user can choose from. When a user doesnt find the effect they want to use, they will click on a 'More...' button at the bottom of the list which would open up the effects dialog and then a user can choose an entry from the list. Once chosen, that entry will now be shown in the condensed list for easy access to the next time the user wants to use it.
Comment 1 V Stuart Foote 2014-12-30 15:48:07 UTC
See source ref for transitions available to LO in https://bugs.freedesktop.org/show_bug.cgi?id=87613#c10
Comment 2 A (Andy) 2014-12-30 22:18:33 UTC
(In reply to Jay Philips from comment #0)
> In impress, in order to add an effect, you click on a add effect button
> which opens up a dialog where you select the effect you want to add. This
> seems to be a very clumsy way of going about this when the contents of this
> dialog could easily be integrated into the sidebar with a drop down list for
> effect category and (ideally) a listbox for the effects list.

In this case you would reduce the large box with the custom animations to have the place for the two list boxes?
Currently, we have a preview included.  Would this also still be possible with this solution?
If you would have selected an animation out of the two list boxes, would you then add it with the + button?

> Another alternative is to have a single drop down list or listbox listing
> the most important entries from each category that a user can choose from.
> When a user doesnt find the effect they want to use, they will click on a
> 'More...' button at the bottom of the list which would open up the effects
> dialog and then a user can choose an entry from the list. Once chosen, that
> entry will now be shown in the condensed list for easy access to the next
> time the user wants to use it.

This feature with the most (user-specific) important entries would be nice.  But with this solution you would have no more the categories listing?  I would prefer to have some sort of category listing.  Otherwise, you would have a very long list if you click on More.  Therefore, I would currently tend more to the first solution with the two list boxes.  But maybe I would also need to see a preview how it would look like.


Further issues:
In Effect Box section the distance between the heading Effect Box and the first drop-down list box line is smaller than for instance in the Slide Transition section of the Sidebar.
The Direction drop-down list box is higher, because of the ... button (?).  Is there also any possibilty to have the same height in all three drop-down list box lines?
Comment 3 Yousuf Philips (jay) 2014-12-31 23:58:12 UTC
Created attachment 111598 [details]
mockup of idea 1
Comment 4 Yousuf Philips (jay) 2015-01-01 00:13:39 UTC
(In reply to A (Andy) from comment #2)
> In this case you would reduce the large box with the custom animations to
> have the place for the two list boxes?

Hope the mockup explains it better. :D

> Currently, we have a preview included.  Would this also still be possible
> with this solution?

There was always a preview checkbox in the sidebar. :D

> If you would have selected an animation out of the two list boxes, would you
> then add it with the + button?

So the behaviour would be like this :-

Add Effect:
1) Press + button
2) Select an effect and its options

Modify Effect:
1) Select an entry in the list
2) Change the settings

> This feature with the most (user-specific) important entries would be nice. 
> But with this solution you would have no more the categories listing?

The list would be categorized based on main category, like below:

Entrance
  Fly In
  Venetian Blinds
Emphasis
  Color Blend
  Lighten

> I would prefer to have some sort of category listing.  Otherwise, you would
> have a very long list if you click on More.

More would open up the same dialog that we see currently.

> Therefore, I would currently
> tend more to the first solution with the two list boxes.  But maybe I would
> also need to see a preview how it would look like.

Think of it like the currently attached mockup and removing the category and its drop down and putting the main category name in the listbox (i.e. replacing 'Basic' with 'Entrance').

> Further issues:
> In Effect Box section the distance between the heading Effect Box and the
> first drop-down list box line is smaller than for instance in the Slide
> Transition section of the Sidebar.
> The Direction drop-down list box is higher, because of the ... button (?). 
> Is there also any possibilty to have the same height in all three drop-down
> list box lines?

Yes ideally all three should be the same height and width, though not sure if it is achievable.
Comment 5 A (Andy) 2015-01-01 10:28:38 UTC
@Jay: Thank you very much for your feedback.

I like the mockup, and I would prefer the first version with the additional categories listbox, because I think due to the many effects the scroll list would otherwise become too large and the scrollbar too small. 

Let's see, what others think about it.
Comment 6 A (Andy) 2015-01-01 11:40:36 UTC
One thing we would also need to think about would be the width of the Sidebar as discussed in Bug 87809.
Comment 7 Yousuf Philips (jay) 2015-04-14 21:52:53 UTC
As a minor tweak to the mockup, it would be good to have the last row align well with the other controls, and also look similar to the how the transition tab looks (attachment 111510 [details]):-

Preview: [✓] Automatic     [Play ►]
Comment 8 Samuel Mehrbrodt (CIB) 2016-01-08 08:50:04 UTC
This is an easy hack. The task is to complete the patch here: https://gerrit.libreoffice.org/#/c/17008/

There are some bugs to fix, see comment from Jay Philips in Gerrit (Aug 23 9:48 PM).
Comment 9 Rishabh 2016-02-03 12:29:39 UTC
(In reply to Samuel Mehrbrodt from comment #8)
> This is an easy hack. The task is to complete the patch here:
> https://gerrit.libreoffice.org/#/c/17008/
> 
> There are some bugs to fix, see comment from Jay Philips in Gerrit (Aug 23
> 9:48 PM).

Hi Samuel,

Apologies for the inactivity. I wish to restart the work on this patch and will start by updating the commit to build in the current master.
Comment 10 Samuel Mehrbrodt (CIB) 2016-02-03 12:33:46 UTC
(In reply to Rishabh from comment #9)
> Apologies for the inactivity. I wish to restart the work on this patch and
> will start by updating the commit to build in the current master.

Hi Rishab, please get in touch with akshaydeepiitr@gmail.com who started working on this yesterday.
Comment 11 Commit Notification 2016-02-04 09:21:19 UTC
Rishabh Kumar committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=e4aa4472f84dc9fcf0acaab80ede005603a4b93c

tdf#87813: Moving effects list into the animation tab

It will be available in 5.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 12 Yousuf Philips (jay) 2016-02-07 15:03:11 UTC
@Rishabh: Glad to finally see this added to master, but there are a number of issues with its behaviour that needs to be fixed, which i had brought up in the merged gerrit patch that needed to be resolved.
Comment 13 Yousuf Philips (jay) 2016-02-07 15:40:55 UTC
1) When nothing is selected, clicking on a entry in the animation list doesnt activate category and effect drop down menus.

2) When pressing the add button, it should select Entrance->Appear not Emphasis->Change Fill Color and no automatic preview should not be executed.

3) When clicking on an entry in Effect, there is refreshing in the sidebar that causes problems. e.g. Effect list refreshes and selected entry goes to the top of the list, flicker of the add/delete/up/down buttons.

4) When changing the Category, the first entry in the Effect list is selected, which would confuse users to believe that it is now selected.

5) When an entry in the animation list is deleted, it should select the entry in the same position. If there isnt any entry in that position because it was the last entry of the list, then it should select the entry above it, if there was one. Basically a user should be able to click the Delete button multiple times without having to select another entry in the animation list.

6) In the Effect drop down menu, it would be useful to have the effect group names (e.g. Basic, Special, ...) left aligned rather than centered and have the effect names indented, similar to a tree view, as it would be easier to view the list.
Comment 14 Commit Notification 2016-02-09 09:28:49 UTC
Rishabh committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=9485104b7cd2f3459d5954df33343bc3cc76a744

tdf#87813: Remove Dead code

It will be available in 5.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 15 Commit Notification 2016-02-10 08:42:12 UTC
Rishabh committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=a04b458821cd4b34b56f406af4620c8df2d5ea12

tdf#87813: Reduce duplicate code

It will be available in 5.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 16 Commit Notification 2016-02-12 15:05:04 UTC
Rishabh committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=662406b44d16c713c3d42585b57caf46689980f0

tdf#87813: Bugfix for the animations sidebar tab

It will be available in 5.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 17 Katarina Behrens (CIB) 2016-02-18 13:15:04 UTC
More issues:

* Given two objects, one with some animations and one without, if I select the object that has no animation assigned yet, the animation list should be cleared 

=> it ain't

* It is possible to add the same animation multiple times

=>  it shouldn't be imho, but it can be discussed (was the same w/ the old dialog)

* Even when I uncheck 'automatic preview', it still shows the preview

=> it shouldn't
Comment 18 Robinson Tryon (qubit) 2016-02-18 14:47:17 UTC Comment hidden (obsolete)
Comment 19 Commit Notification 2016-02-22 09:21:09 UTC
Rishabh committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=3a34e0a2cba570f8d2728bbbf3dcb658aff6b983

tdf#87813:Fix 'Automatic Preview' feature in sidebar Slide Animation Panel

It will be available in 5.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 20 jani 2016-04-18 07:13:46 UTC
solved
Comment 21 Yousuf Philips (jay) 2016-04-18 20:23:03 UTC
Returning it back to NEW as more work is needed to be completed for this can be closed as FIXED, which i assume Rishabh and Susobhang will be doing soon.
Comment 22 jani 2016-04-18 21:07:46 UTC
(In reply to Yousuf (Jay) Philips from comment #21)
> Returning it back to NEW as more work is needed to be completed for this can
> be closed as FIXED, which i assume Rishabh and Susobhang will be doing soon.

no problem, but NEW is not correct, sunce it is assigned.
Comment 23 jani 2016-05-19 06:01:58 UTC
A polite ping, still working on this patch ?
Comment 24 Yousuf Philips (jay) 2016-05-19 07:03:59 UTC
Yes Susobhang will be working on this for GSoC.
Comment 25 jani 2016-06-20 05:37:52 UTC
A polite ping, still working on this issue ?
Comment 26 jani 2016-07-21 07:29:38 UTC
Unassigning due to lack of work. Remark you can anytime assign it to yourself again.
Comment 27 Gizze 2016-10-22 13:00:43 UTC
Custom Animation pane:
The type of animation was added to the list of animated objects in the white pane.
In my view that makes this list overcrowded if you have multiple animations.
Comment 28 Yousuf Philips (jay) 2016-10-22 17:16:34 UTC
(In reply to Gizze from comment #27)
> In my view that makes this list overcrowded if you have multiple animations.

Yes on a small screen (e.g. 1280x768), the 136px (7.25 text lines) height of the effect listbox (effect_list) takes up a significant amount of space when compared to the 186px height being used for the custom animation list listbox (Custom Animation ListBox-selection1).

Not sure what can be done to improve this other than possibly reducing the effect listbox to 92px (~5 text lines).

http://opengrok.libreoffice.org/xref/core/sd/source/ui/animations/CustomAnimationPane.cxx#187
Comment 29 Gizze 2016-10-22 19:11:56 UTC
Created attachment 128166 [details]
Old Custom Animation Pane

Old (pre 5.2) Custom Animation pane only showing the animation sequence
Comment 30 Gizze 2016-10-22 19:15:55 UTC
Created attachment 128167 [details]
New Custom Animation Pane

New (5.2) Custom Animation Pane also showing the effect type along with the animation sequence
Comment 31 Gizze 2016-10-22 19:21:29 UTC
I am afraid I did not get my point across properly.
I referred to the upper part of the Custom Animation pane where the animation sequence is shown.
In the new version also the effect type is listed. This may be neat if there are only few animation steps.
If there are detailed animations, however, I feel that the overview gets lost. 
I attached two screenshots to illustrate this.
Comment 32 Yousuf Philips (jay) 2016-10-23 14:36:38 UTC
(In reply to Gizze from comment #31)
> I referred to the upper part of the Custom Animation pane where the
> animation sequence is shown.

The custom animation sequence list was changed in bug 87812.

> In the new version also the effect type is listed. This may be neat if there
> are only few animation steps.
> If there are detailed animations, however, I feel that the overview gets
> lost. 

The old single line of information for a custom animation in the list doesnt provide sufficient information at a glance, which is why it was changed.
Comment 33 Gizze 2016-10-23 19:05:04 UTC
Well, I guess it is not possible to make everybody happy and you guys discussed that thoroughly.
But this new layout is actually why I went back from 5.2 to 5.1.
I guess I have to get used to that sooner or later.
Thanks for all your efforts here anyway. I appreciate your enthusiasm.